/* tslint:disable */
/* eslint-disable */

/* auto-generated by NAPI-RS */

export const enum BSAction {
  Buy = 'Buy',
  Sell = 'Sell'
}
export const enum TimeInForce {
  ROD = 'ROD',
  FOK = 'FOK',
  IOC = 'IOC'
}
export const enum OrderType {
  Stock = 'Stock',
  Margin = 'Margin',
  Short = 'Short',
  DayTradeShort = 'DayTradeShort',
  Unsupport = 'Unsupport'
}
export const enum PriceType {
  Limit = 'Limit',
  Market = 'Market',
  LimitUp = 'LimitUp',
  LimitDown = 'LimitDown',
  Reference = 'Reference'
}
export const enum MarketType {
  Common = 'Common',
  Fixing = 'Fixing',
  Odd = 'Odd',
  IntradayOdd = 'IntradayOdd',
  Emg = 'Emg'
}
export const enum QueryType {
  All = 0,
  Reservation = 1,
  RegularSession = 2,
  Cancelable = 3,
  Failed = 4
}
export interface Order {
  /** 盤別 */
  marketType: MarketType
  /** 買賣別 */
  buySell: BSAction
  /** 商品代碼 */
  symbol: string
  /** 價格別 */
  priceType: PriceType
  /** 價格 */
  price?: string
  /** 股/口數 */
  quantity: number
  /** ROD/FOK/IOC */
  timeInForce: TimeInForce
  /** 交易別 */
  orderType: OrderType
}
export interface ShortResourceOutput {
  quota?: string
  total?: string
  used?: string
}
export interface MarginShortQuotaOutput {
  symbol?: string
  kind?: string
  tqty?: string
  stop?: string
  crPercentage?: string
  dbPercentage?: string
  blMark?: string
  crStatus?: string
  dbStatus?: string
  crFlag?: string
  luMsg?: string
  dteMsg?: string
}
export interface OrderRecord {
  workDate?: string
  orderDate?: string
  orderTime?: string
  sysCode?: string
  orderNo?: string
  symbol?: string
  buySell?: BSAction
  market?: string
  marketType: MarketType
  priceType: PriceType
  timeInForce?: TimeInForce
  orderType?: OrderType
  orderPrice: number
  orgQty: number
  filledQty: number
  celQty: number
  canCancel: boolean
  errCode?: string
  errMsg?: string
  seqNo?: string
  isPreOrder?: boolean
  preOrderNo?: string
  avgPrice?: number
  chgTime?: string
  chgDate?: string
}
export interface PlaceOrderResponse {
  orderDate: string
  orderTime: string
  workDate: string
  isPreOrder: boolean
  orderNo: string
}
export interface ModifiedResponse {
  orderDate: string
  orderTime: string
}
export interface FilledRecordOutput {
  orderNo?: string
  sysCode?: string
  symbol?: string
  mktSeqNo?: string
  marketType: MarketType
  market?: string
  buySell?: BSAction
  orderType?: OrderType
  payment: number
  filledDate?: string
  filledTime?: string
  filledQty: number
  filledPrice: number
}
export interface AlertStockOutput {
  marketType?: number
  symbol?: string
  lowerLimitPrice: number
  closingPrice: number
  upperLimitPrice: number
  alertStartDate?: string
  alertEndDate?: string
  alertHandlingMode: number
  stockName?: string
  messageDescription?: string
  shortSellingAtParMark?: string
  shortSellingAtParAllowed?: string
  dayTradingAndAccount98Status?: string
}
export interface StockStatusOutput {
  symbol?: string
  abnormalRecommendationMark?: string
  abnormalDescription?: string
  specialAbnormalMark?: string
  specialAbnormalDescription?: string
  dispositionStockMark?: string
  dispositionDescription?: string
  internalControlCategory?: string
  internalControlDescription?: string
}
export interface FilledDetailOutput {
  orderNo?: string
  sysCode?: string
  symbol?: string
  marketType: number
  market?: string
  buySell?: BSAction
  orderType?: string
  payment: number
  filledDate?: string
  filledQty: number
  filledAvgPrice: number
}
export interface AccountInfoWrapper {
  accounts?: Array<Account>
}
export interface Account {
  branchName?: string
  account: string
  accountType?: string
  sMark?: string
  name?: string
}
export interface AccountQuickInquiryResponse {
  unrealizedProfitLossCash?: string
  unrealizedProfitLossMargin?: string
  unrealizedProfitLossShortSelling?: string
  unrealizedProfitLossTotal?: string
  realizedProfitLossCash?: string
  realizedProfitLossMargin?: string
  realizedProfitLossShortSelling?: string
  realizedProfitLossTotal?: string
  dayTradingProfitLossCredit?: string
  dayTradingProfitLossCash?: string
  netAmount?: string
  accountMaintenanceRate?: string
  totalProfitLossCash?: string
  totalProfitLossMargin?: string
  totalProfitLossShortSelling?: string
  totalProfitLoss?: string
}
export interface PaymentResponse {
  sDate?: string
  tDate?: string
  netAmount?: string
  settleSum?: SettlementSummary
  settleCreditSum?: SettlementMarginSummary
  settleDebitSum?: SettlementShortSummary
}
export interface SettlementSummary {
  buyAmount?: string
  sellAmount?: string
  fee?: string
  tax?: string
  netAmount?: string
}
export interface SettlementMarginSummary {
  marginQuantity?: string
  marginQuantityLeft?: string
  openShortCollateral?: string
  openShortCollateralBuy?: string
  openShortCollateralSell?: string
  marginAmount?: string
  marginAmountBuy?: string
  marginAmountSell?: string
  marginNetAmountBuy?: string
  marginNetAmountSell?: string
  interest?: string
  fee?: string
  tax?: string
  netAmount?: string
}
export interface SettlementShortSummary {
  shortQuantity?: string
  shortQuantityLeft?: string
  guaranteeAmount?: string
  guaranteeAmountBuy?: string
  guaranteeAmountSell?: string
  shortCollateral?: string
  shortCollateralBuy?: string
  shortCollateralSell?: string
  shortNetAmountBuy?: string
  shortNetAmountSell?: string
  shortSellingFee?: string
  interest?: string
  netAmount?: string
}
export interface PositionResponse {
  no?: string
  prevDayQuantity?: string
  currentQuantity?: string
  todayQuantity?: string
  todayBuyQuantity?: string
  todaySellQuantity?: string
  cost?: string
  marketValue?: string
  unrealizedProfitLoss?: string
  unrealizedProfitLossRate?: string
  securitiesTransactionIncomeTax?: string
  healthInsuranceFee?: string
  fee?: string
  tax?: string
  openMarginAmount?: string
  openGuaranteeAmount?: string
  openShortCollateral?: string
  shortSellingFee?: string
  ownFundsAmount?: string
  otherCost?: string
  interest?: string
  unrealizedNetAmount?: string
  totalProfitLoss?: string
  realizedProfitLoss?: string
  dividendAmount?: string
  accountSummary?: AccountSummary
  positionSummaries?: Array<PositionSummary>
}
export interface AccountSummary {
  marginPositionMarketValueSum?: string
  shortPositionMarketValueSum?: string
  shortCollateralSum?: string
  marginLimit?: string
  shortLimit?: string
  guaranteeAmountSum?: string
  marginAmountSum?: string
  shortAmountSum?: string
  accountMaintenanceRate?: string
  settlementToday?: string
  settlementYesterday?: string
  settlementNet?: string
}
export interface PositionSummary {
  branchId?: string
  custId?: string
  no?: string
  symbol?: string
  name?: string
  symbolName?: string
  stockEvaluation?: string
  orderType?: string
  orderTypeName?: string
  buySell?: BSAction
  prevDayQuantity?: string
  currentQuantity?: string
  totalQuantity?: string
  totalBuyQuantity?: string
  totalSellQuantity?: string
  cost?: string
  costBeforeDividend?: string
  averagePrice?: string
  openMarginAmount?: string
  guaranteeAmount?: string
  openGuaranteeAmount?: string
  shortCollateral?: string
  openShortCollateral?: string
  shortSellingFee?: string
  ownFundsAmount?: string
  guaranteeDefaultAmount?: string
  currentPrice?: string
  marketValue?: string
  unrealizedProfit?: string
  unrealizedProfitLossRate?: string
  fee?: string
  tax?: string
  interest?: string
  otherCost?: string
  unrealizedNetAmount?: string
  targetPrice?: string
  portfolioType?: string
  holdingPercent?: string
  securitiesIncomeTax?: string
  healthInsuranceFee?: string
  referencePrice?: string
  totalProfit?: string
  realizedProfit?: string
  pledgeQuantity?: string
  amount?: string
  averageFilledPrice?: string
  breakEvenPrice?: string
  dividendAmount?: string
  positionDetails?: Array<PositionDetail>
}
export interface PositionDetail {
  no?: string
  tDate?: string
  orderType?: string
  orderTypeName?: string
  buySell?: BSAction
  delegateSequence?: string
  filledNo?: string
  filledQuantity?: string
  prevDayQuantity?: string
  filledPrice?: string
  filledAmount?: string
  currentPrice?: string
  marketValue?: string
  marginAmount?: string
  openMarginAmount?: string
  shortCollateral?: string
  openShortCollateral?: string
  guaranteeAmount?: string
  openGuaranteeAmount?: string
  securitiesLendingFee?: string
  shortSellingFee?: string
  fee?: string
  tax?: string
  interest?: string
  cost?: string
  costBeforeDividend?: string
  changeType?: string
  ownFundsAmount?: string
  portfolioType?: string
  custId?: string
  name?: string
  branchId?: string
  otherCost?: string
  isAdjusted?: string
  securitiesIncomeTax?: string
  healthInsuranceFee?: string
  unrealizedProfitLoss?: string
  unrealizedProfitLossRate?: string
  referencePrice?: string
  ioFlag?: string
  ioName?: string
  breakEvenPrice?: string
  dividendAmount?: string
  guaranteeDefaultAmount?: string
}
export interface RealizedProfitLossResponse {
  no?: string
  cost?: string
  income?: string
  profitLoss?: string
  profitLossRate?: string
  accumulatedCost?: string
  accumulatedProfitLoss?: string
  accumulatedProfitLossRate?: string
  shortSellingFee?: string
  interest?: string
  closedMarginAmount?: string
  dividendAmount?: string
  securitiesLendingDifferentialFee?: string
  profitLossSummary?: Array<RealizedProfitLossSummary>
}
export interface RealizedProfitLossSummary {
  no?: string
  tDate?: string
  filledNo?: string
  closedQuantity?: string
  filledPrice?: string
  closedMarginAmount?: string
  closedShortCollateral?: string
  closedGuaranteeAmount?: string
  interest?: string
  shortSellingFee?: string
  cost?: string
  costBeforeDividend?: string
  income?: string
  profitLoss?: string
  profitLossRate?: string
  otherCost?: string
  closedType?: string
  orderTypeName2?: string
  dividendAmount?: string
  securitiesLendingDifferentialFee?: string
  branchId?: string
  custId?: string
  name?: string
  orderType?: string
  orderTypeName?: string
  buySell?: BSAction
  symbol?: string
  symbolName?: string
  targetPrice?: string
  portfolioType?: string
  buyDetail?: RealizedProfitLossDetail
  sellDetail?: RealizedProfitLossDetail
}
export interface RealizedProfitLossDetail {
  no?: string
  tDate?: string
  orderNo?: string
  filledNo?: string
  closedQuantity?: string
  filledPrice?: string
  closedMarginAmount?: string
  closedShortCollateral?: string
  closedGuaranteeAmount?: string
  fee?: string
  interest?: string
  tax?: string
  shortSellingFee?: string
  cost?: string
  costBeforeDividend?: string
  income?: string
  profitLoss?: string
  profitLossRate?: string
  otherCost?: string
  closedType?: string
  securitiesTransactionTax?: string
  healthInsurancePremium?: string
  orderTypeName2?: string
  dividendAmount?: string
  securitiesLendingDifferentialFee?: string
  filledQuantity?: string
  filledAmount?: string
  netAmount?: string
  marginAmount?: string
  guaranteeAmount?: string
  shortCollateral?: string
  securitiesLendingFee?: string
  adjustmentDate?: string
  orderType?: string
  orderTypeName?: string
  buySell?: string
  changeType?: string
  isAdjusted?: string
  ioFlag?: string
  ioName?: string
}
export interface StatementFilledProfile {
  branchId?: string
  custId?: string
  name?: string
  symbol?: string
  symbolName?: string
  filledDate?: string
  orderNo?: string
  filledNo?: string
  orderType?: string
  orderTypeName?: string
  buySell?: string
  buySellName?: string
  marketType?: string
  filledPrice?: string
  filledQty?: string
  filledAmount?: string
  tax?: string
  fee?: string
  interest?: string
  reverseInterest?: string
  marginAmount?: string
  shortAmount?: string
  shortCollateral?: string
  guaranteeAmount?: string
  shortSellingFee?: string
  income?: string
  cost?: string
  securitiesLendingFee?: string
  netAmount?: string
  ownFundsAmount?: string
  profitLoss?: string
  securitiesTransactionIncomeTax?: string
  healthInsuranceFee?: string
  isDayTrade?: string
  securitiesLendingDifferentialFee?: string
}
export interface StatementResponse {
  income?: string
  cost?: string
  netAmount?: string
  fee?: string
  tax?: string
  marginShortDayTradingProfitLoss?: string
  commonStockDayTradingProfitLoss?: string
  securitiesIncomeTax?: string
  healthInsuranceFee?: string
  filledQuantity?: string
  interest?: string
  shortSellingFee?: string
  filledAmount?: string
  paymentGrossTotal?: string
  profitLoss?: string
  creditDebitNetAmount?: string
  securitiesLendingDifferentialFee?: string
  accountSummary?: AccountSummary
  billSummary?: BillSummary
  filledRecords?: Array<StatementFilledProfile>
}
export interface BillSummary {
  commonStockBuyAmount?: string
  commonStockSellAmount?: string
  commonStockFee?: string
  commonStockTax?: string
  commonStockStInTax?: string
  commonStockNetAmount?: string
  ownFundsAmount?: string
  marginAmount?: string
  marginFee?: string
  marginInterest?: string
  marginTax?: string
  marginSecuritiesIncomeTax?: string
  marginNetAmount?: string
  guaranteeAmount?: string
  shortCollateral?: string
  shortFee?: string
  shortInterest?: string
  shortHealthInsuranceFee?: string
  shortNetAmount?: string
  profitLoss?: string
  buyQuantity?: string
  sellQuantity?: string
  netAmount?: string
  securitiesLendingDifferentialFee?: string
}
export interface SettlementResponse {
  accountSummary?: AccountSummary
  settlements?: Array<SettlementDailySummary>
}
export interface SettlementDailySummary {
  branchId?: string
  custId?: string
  sDate?: string
  tDate?: string
  netAmount?: string
}
export interface RealtimePositionQuantityOutput {
  symbol?: string
  marketType?: string
  commonStockQuantity?: string
  marginStockQuantity?: string
  shortSellingQuantity?: string
  oddLotQuantity?: string
  currentPrice?: string
  marketValue?: string
  realTimeDepositoryQuantity?: string
  realTimeMarginQuantity?: string
  realTimeShortSellingQuantity?: string
  realTimeOddLotQuantity?: string
  todayDepositoryBuyOrderQuantity?: string
  todayMarginBuyOrderQuantity?: string
  todayShortSellingBuyOrderQuantity?: string
  todayOddLotBuyOrderQuantity?: string
  todayDepositorySellOrderQuantity?: string
  todayMarginSellOrderQuantity?: string
  todayShortSellingSellOrderQuantity?: string
  todayOddLotSellOrderQuantity?: string
  todayDepositoryBuyExecutedQuantity?: string
  todayMarginBuyExecutedQuantity?: string
  todayShortSellingBuyExecutedQuantity?: string
  todayOddLotBuyExecutedQuantity?: string
  todayDepositorySellExecutedQuantity?: string
  todayMarginSellExecutedQuantity?: string
  todayShortSellingSellExecutedQuantity?: string
  todayOddLotSellExecutedQuantity?: string
}
export interface SkBankBalanceResponse {
  balance: number
  availableBalance: number
  currency?: string
  branchId?: string
  custId?: string
  bankAccount?: string
}
export interface PassbookBalanceOutput {
  availableBalance: number
  reservedAmount: number
  dedicatedAccountBalance: number
  withdrawalBankCode?: string
  withdrawalBank?: string
  withdrawalAccount?: string
  depositBankCode?: string
  depositAccount?: string
}
export interface TradingSchedule {
  regular: TimeRange
  afterMarket: TimeRange
  oddLot: TimeRange
  intradayOddLot: TimeRange
  emg: TimeRange
  isTradingDay: boolean
  lastTradingDay: string
  nextTradingDay: string
  nextTradingDay2: string
}
export interface TimeRange {
  openTime: string
  closeTime: string
}
export interface LoginResponse {
  authToken: string
  accountInfos: Array<Account>
}
export interface RealtimeTokenOutput {
  realtimeToken: string
}
export interface MatObject {
  filledTime: string
  filledPrice: number
  payPrice: number
  mktSeqNo: string
  lineNo: string
  kind: string
  account: string
  orderNo: string
  orgSysCode: string
  symbol: string
  marketType: MarketType
  buySell: BSAction
  orderType: OrderType
  filledQty: number
  orderSeqNo: string
}
export interface AckObject {
  workDate: string
  orderDateTime: string
  orgRequestNo: string
  sysCode: string
  requestNo: string
  isPreOrder: boolean
  orgPreOrderNo: string
  priceType: PriceType
  orderPrice: number
  orgQty: number
  celQty: number
  canCancel: boolean
  errCode?: string
  errMsg: string
  act: string
  beforeQty: number
  afterQty: number
  timeInForce?: TimeInForce
  lineNo: string
  kind: string
  account: string
  orderNo: string
  orgSysCode: string
  symbol: string
  symbolName?: string
  boardLot?: number
  marketType: MarketType
  buySell: BSAction
  orderType: OrderType
  filledQty: number
  orderSeqNo: string
}
export type JsAccounting = Accounting
export declare class Accounting {
  constructor()
  inventories(account: Account): PositionResponse
  realizedProfitAndLoses(account: Account, from: string, to: string, symbol?: string | undefined | null): RealizedProfitLossResponse
  accountStatment(account: Account, from: string, to: string, symbol?: string | undefined | null): StatementResponse
  todaySettlement(account: Account): PaymentResponse
  historySettlement(account: Account, from: string, to: string): SettlementResponse
  accountTotalPnl(account: Account): AccountQuickInquiryResponse
  todayTradeSummary(account: Account, symbol?: string | undefined | null): Array<RealtimePositionQuantityOutput>
  skbankBalance(account: Account): SkBankBalanceResponse
  bankBalance(account: Account): Array<PassbookBalanceOutput>
}
export type JsStock = Stock
export declare class Stock {
  constructor()
  getOrderResults(account: Account, queryType?: QueryType | undefined | null, symbol?: string | undefined | null): Array<OrderRecord>
  orderHistory(account: Account, from: string, to: string, symbol?: string | undefined | null): Array<OrderRecord>
  placeOrder(account: Account, order: Order): PlaceOrderResponse
  modifyVolume(account: Account, orderResult: OrderRecord, celQty: number): ModifiedResponse
  modifyPrice(account: Account, orderResult: OrderRecord, newPrice: string, newPriceType: PriceType): ModifiedResponse
  getFilled(account: Account, symbol?: string | undefined | null): Array<FilledRecordOutput>
  filledHistory(account: Account, from: string, to: string, symbol?: string | undefined | null): Array<FilledRecordOutput>
  getFilledDetail(account: Account, symbol?: string | undefined | null): Array<FilledDetailOutput>
  filledDetailHistory(account: Account, from: string, to: string, symbol?: string | undefined | null): Array<FilledDetailOutput>
  marginQuota(account: Account, symbol: string, queryType: string): MarginShortQuotaOutput
  queryAttentionStock(account: Account, symbol?: string | undefined | null): Array<AlertStockOutput>
  queryDispositionStock(account: Account, symbol: string): Array<StockStatusOutput>
  shortDaytradeQuota(account: Account, symbol: string): ShortResourceOutput
}
export type JsCoreSDK = CoreSdk
export declare class CoreSdk {
  constructor(apiUrl?: string | undefined | null)
  /**
   * Stock trading function
   *
   * Function include : placeOrder() ,  modifyPrice(), cancelOrder() …etc
   */
  get stock(): Stock
  /**
   * Stock account data query
   *
   * Function include : inventories(), realizedGainsAndLoses(), maintenance().....etc
   */
  get accounting(): Accounting
  login(personalId: string, pass: string, certPath: string, certPass?: string | undefined | null): Array<Account>
  registerApiAuth(account: Account): boolean
  getMarketTime(account: Account, date: string): TradingSchedule
  getRealtimeToken(account: Account): RealtimeTokenOutput
  connectWebsocket(): void
  setOnFilled(callback: (err: null | Error, event: MatObject) => void): void
  setOnOrder(callback: (err: null | Error, event: AckObject) => void): void
  setOnError(callback: (err: null | Error, event: String) => void): void
  setOnDisconnected(callback: (err: null | Error, event: String) => void): void
}
export declare class FugleRealtime {
  
  constructor()
  get realtimeRestUrl(): string
  get realtimeWsNormalUrl(): string
  get realtimeWsSpeedUrl(): string
}
