// const { BSAction, TimeInForce, OrderType, PriceType, MarketType, Accounting, CoreSdk, FugleRealtime } =
const { CoreSdk, FugleRealtime, ...rest } = require('./core.js');
const { RestClient, WebSocketClient, Mode } = require('./marketdata/index.js');
const version = require('./package.json').version;
const fugleRealtime = new FugleRealtime();

class MasterlinkSDK extends CoreSdk {
  /**
   * constructor of FubonSDK
   * @param {string | null } url The first value
   */
  constructor(url) {
    super(url);
    global.__fubon_sdk_ref__ = this;
  }

  /**
   * Initial market data and get authorised
   */
  initRealtime(account, mode = Mode.Normal) {
    const realtimeResult = super.getRealtimeToken(account);
    this.marketdata = {
      webSocketClient: new WebSocketClient({ bearerToken: realtimeResult.realtimeToken }, mode),
      restClient: new RestClient({ bearerToken: realtimeResult.realtimeToken }),
    }
  }

  // /**
  //  * add callback to Order
  //  * @param {(err: null | Error, event: OrderResult)} callback The first value
  //  */
  // setOnOrder(callback) {
  //   super.innerSetOnOrder(function (_err, event) {
  //     if (event.isSuccess) {
  //       callback(null, event.data)
  //     } else {
  //       callback(new Error(event.message), event.data)
  //     }
  //   })
  // }

  // /**
  //  * add callback to OrderChanged
  //  * @param {(err: null | Error, event: FutOptOrderResult)} callback The first value
  //  */
  // setOnOrderChanged(callback) {
  //   super.innerSetOnOrderChanged(function (_err, event) {
  //     if (event.isSuccess) {
  //       callback(null, event.data)
  //     } else {
  //       callback(new Error(event.message), event.data)
  //     }
  //   })
  // }
}

module.exports = {
  ...rest,
  MasterlinkSDK,
}
