const { MasterlinkSDK } = require('./index.js');

// const sdk = new MasterlinkSDK();

const sdk = new MasterlinkSDK("https://masterlink-dev.fugle.tw")

console.log(sdk.login)

// const accounts = sdk.login("Your ID", "Your Password", "Your Cert Path", "Your Cert Password");

const accounts = sdk.login("", "000000", "/Users/bistin/Downloads/ca/-ML.pfx", "000000")

sdk.initRealtime(); // 建立行情連線

const client = sdk.marketdata.restClient

client.stock.intraday.ticker({ symbol: '2330' })
  .then(data => console.log(data));

const stock = sdk.marketdata.webSocketClient.stock;

stock.on("message", (message) => {
  const data = JSON.parse(message);
  console.log(data);
});

(async () => {
    await stock.connect();

    stock.subscribe({
        'channel': 'trades',
        'symbol': '2881'
    });
})()
